package application.usecase;

import application.exception.GatewayServiceException;
import application.port.input.IUserLogin;
import application.port.input.command.UserLoginCommand;
import com.banesco.common.infraestructure.helpers.LoggerHelper;
import domain.model.UserLogin;
import domain.repository.IUserLoginPort;
import jakarta.enterprise.context.ApplicationScoped;
import lombok.extern.slf4j.Slf4j;

import java.util.Optional;

@Slf4j
@ApplicationScoped
public class UserLoginUseCase implements IUserLogin {

    private final IUserLoginPort userLoginApiPort;

    public UserLoginUseCase(IUserLoginPort userLoginApiPort) {
        this.userLoginApiPort = userLoginApiPort;
    }

    /**
     *  Orquesta la ejecución del caso de uso de login de usuario
     * Encapsula la lógica de negocio, incluyendo la generación de códigos de referencia
     * y el manejo de fallos de comunicación con el servicio externo.
     * @param command El comando con los datos de entrada para el login.
     * @param requestId El ID de la solicitud para trazabilidad.
     * @return Un {@link Optional} con el objeto {@link UserLogin} si el login fue exitoso,
     * o un {@code Optional.empty()} si falló por cualquier motivo.
     */
    @Override
    public Optional<UserLogin> execute(UserLoginCommand command, String requestId) {
        log.debug(LoggerHelper.buildInfoPrivateRequest(requestId, "Iniciando caso de uso: User Login"));
        try {
            var result = userLoginApiPort.execute(command, requestId);

            if(result == null) {
                log.error(LoggerHelper.buildError(requestId, " El login no fue exitoso segun la respuesta del servicio"));
                return Optional.empty();
            }

            log.debug(LoggerHelper.buildInfoPrivateResponse(requestId, "Finalizado caso de uso: User Login"));
            return Optional.of(result);
        } catch (GatewayServiceException ex) {
            log.error(LoggerHelper.buildError(requestId, "Fallo la comunicacion con el servicio de User Login"));
            throw  ex;
        }
    }

}